{************************************************************************}
{*             $ Datum: 26.12.2000     Zeit: 16:46:00 $                 *}
{************************************************************************}

unit DiskUtil;

{------------------------------------------------------------------------------}

interface

{------------------------------------------------------------------------------}

uses Windows, SysUtils, Util;

{------------------------------------------------------------------------------}

const
  SHFMT_DRV_A                       = 0;
  SHFMT_DRV_B                       = 1;
  SHFMT_ID_DEFAULT                  = $FFFF;
  SHFMT_OPT_QUICKFORMAT             = 0;
  SHFMT_OPT_FULLFORMAT              = 1;
  SHFMT_OPT_SYSONLY                 = 2;
  SHFMT_ERROR                       = -1;
  SHFMT_CANCEL                      = -2;
  SHFMT_NOFORMAT                    = -3;

  IOCTL_BATTERY_QUERY_TAG           = $294040;
  IOCTL_BATTERY_QUERY_INFORMATION   = $294044;
  IOCTL_BATTERY_SET_INFORMATION     = $298048;
  IOCTL_BATTERY_QUERY_STATUS        = $29404C;

  IOCTL_KS_PROPERTY                 = $2F0003;
  IOCTL_KS_ENABLE_EVENT             = $2F0007;
  IOCTL_KS_DISABLE_EVENT            = $2F000B;
  IOCTL_KS_METHOD                   = $2F000F;
  IOCTL_KS_WRITE_STREAM             = $2F8013;
  IOCTL_KS_READ_STREAM              = $2F4017;
  IOCTL_KS_RESET_STATE              = $2F001B;
  IOCTL_KS_HANDSHAKE                = $2F001F;

  IOCTL_NDIS_QUERY_GLOBAL_STATS     = $170002;
  IOCTL_NDIS_QUERY_ALL_STATS        = $170006;
  IOCTL_NDIS_DO_PNP_OPERATION       = $170008;
  IOCTL_NDIS_QUERY_SELECTED_STATS   = $17000E;
  IOCTL_NDIS_ENUMERATE_INTERFACES   = $170010;
  IOCTL_NDIS_ADD_TDI_DEVICE         = $170014;
  IOCTL_NDIS_GET_DEVICE_BUNDLE      = $17001A;
  IOCTL_NDIS_GET_LOG_DATA           = $17001E;

  IOCTL_SMARTCARD_POWER             = $310004;
  IOCTL_SMARTCARD_GET_ATTRIBUTE     = $310008;
  IOCTL_SMARTCARD_SET_ATTRIBUTE     = $31000C;
  IOCTL_SMARTCARD_CONFISCATE        = $310010;
  IOCTL_SMARTCARD_TRANSMIT          = $310014;
  IOCTL_SMARTCARD_EJECT             = $310018;
  IOCTL_SMARTCARD_SWALLOW           = $31001C;
  IOCTL_SMARTCARD_IS_PRESENT        = $310028;
  IOCTL_SMARTCARD_IS_ABSENT         = $31002C;
  IOCTL_SMARTCARD_SET_PROTOCOL      = $310030;
  IOCTL_SMARTCARD_GET_STATE         = $310038;
  IOCTL_SMARTCARD_GET_LAST_ERROR    = $31003C;
  IOCTL_SMARTCARD_GET_PERF_CNTR     = $310040;

  IOCTL_STORAGE_BASE                = $2D;
  IOCTL_STORAGE_CHECK_VERIFY        = $2D4800;
  IOCTL_STORAGE_CHECK_VERIFY2       = $2D0800;
  IOCTL_STORAGE_MEDIA_REMOVAL       = $2D4804;
  IOCTL_STORAGE_EJECT_MEDIA         = $2D4808;
  IOCTL_STORAGE_LOAD_MEDIA          = $2D480C;
  IOCTL_STORAGE_LOAD_MEDIA2         = $2D080C;
  IOCTL_STORAGE_RESERVE             = $2D4810;
  IOCTL_STORAGE_RELEASE             = $2D4814;
  IOCTL_STORAGE_FIND_NEW_DEVICES    = $2D4818;
  IOCTL_STORAGE_EJECTION_CONTROL    = $2D0940;
  IOCTL_STORAGE_MCN_CONTROL         = $2D0944;
  IOCTL_STORAGE_GET_MEDIA_TYPES     = $2D0C00;
  IOCTL_STORAGE_GET_MEDIA_TYPES_EX  = $2D0C04;
  IOCTL_STORAGE_RESET_BUS           = $2D5000;
  IOCTL_STORAGE_RESET_DEVICE        = $2D5004;
  IOCTL_STORAGE_GET_DEVICE_NUMBER   = $2D1080;
  IOCTL_STORAGE_PREDICT_FAILURE     = $2D1100;

  IOCTL_DISK_BASE                   = $7;
  IOCTL_DISK_GET_DRIVE_GEOMETRY     = $70000;
  IOCTL_DISK_GET_PARTITION_INFO     = $74004;
  IOCTL_DISK_SET_PARTITION_INFO     = $7C008;
  IOCTL_DISK_GET_DRIVE_LAYOUT       = $7400C;
  IOCTL_DISK_SET_DRIVE_LAYOUT       = $7C010;
  IOCTL_DISK_VERIFY                 = $70014;
  IOCTL_DISK_FORMAT_TRACKS          = $7C018;
  IOCTL_DISK_REASSIGN_BLOCKS        = $7C01C;
  IOCTL_DISK_PERFORMANCE            = $70020;
  IOCTL_DISK_IS_WRITABLE            = $70024;
  IOCTL_DISK_LOGGING                = $70028;
  IOCTL_DISK_FORMAT_TRACKS_EX       = $7C02C;
  IOCTL_DISK_HISTOGRAM_STRUCTURE    = $70030;
  IOCTL_DISK_HISTOGRAM_DATA         = $70034;
  IOCTL_DISK_HISTOGRAM_RESET        = $70038;
  IOCTL_DISK_REQUEST_STRUCTURE      = $7003C;
  IOCTL_DISK_REQUEST_DATA           = $70040;
  IOCTL_DISK_CONTROLLER_NUMBER      = $70044;

  SMART_GET_VERSION                 = $74080;
  SMART_SEND_DRIVE_COMMAND          = $7C084;
  SMART_RCV_DRIVE_DATA              = $7C088;

  FmtUnknown                        = $00;
  F5_1Pt2_512                       = $01;
  F3_1Pt44_512                      = $02;
  F3_2Pt88_512                      = $03;
  F3_20Pt8_512                      = $04;
  F3_720_512                        = $05;
  F5_360_512                        = $06;
  F5_320_512                        = $07;
  F5_320_1024                       = $08;
  F5_180_512                        = $09;
  F5_160_512                        = $0A;
  RemovableMedia                    = $0B;
  FixedMedia                        = $0C;

{------------------------------------------------------------------------------}

type
  TSector = array[0..511] of Byte;
  TTrack = array[1..18] of TSector;

  TFormatParameters = record
    MediaType: LongInt;
    StartCylinderNumber: Cardinal;
    EndCylinderNumber: Cardinal;
    StartHeadNumber: Cardinal;
    EndHeadNumber: Cardinal;
  end;

  TDiskGeometry = record
    Cylinders: Int64;
    Mediatype: Cardinal;
    TracksPerCylinder: Cardinal;
    SectorsPerTrack: Cardinal;
    BytesPerSector: Cardinal;
  end;

{------------------------------------------------------------------------------}

function  MediaTypeToStr(MediaType: LongInt): String;
function  GetLastErrorStr: String;
function  GetDriveGeometry(var DiskGeometry: TDiskGeometry): Boolean;
function  FormatTracks(MediaTyp: Cardinal; StartCylinder, EndCylinder, StartHead, EndHead: DWord): Boolean;
function  ReadSector(var Buffer: TSector): Boolean;
function  WriteSector(var Buffer: TSector): Boolean;
function  SHFormatDrive(hWnd : HWND; Drive : Word; fmtID : Word; Options : Word) : Longint; stdcall; external 'Shell32.dll' name 'SHFormatDrive';
function  DiskInDrive: Boolean;
function  WaitForDisk: Boolean;
function  ReadTrack(var Buffer: TTrack): Boolean;
function  WriteTrack(var Buffer: TTrack): Boolean;
function  OpenDevice(Drive: Char): Boolean;
procedure SeekToPos(Pos: DWord);
procedure CloseDevice;

{------------------------------------------------------------------------------}

implementation

var hDevice: THandle;

{------------------------------------------------------------------------------}

function OpenDevice(Drive: Char): Boolean;
begin
  hDevice := CreateFile(PChar(Format('\\.\%s:', [UpCase(Drive)])),
               GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  Result := (hDevice <> INVALID_HANDLE_VALUE);
end;

{------------------------------------------------------------------------------}

procedure CloseDevice;
begin
  if hDevice <> INVALID_HANDLE_VALUE then begin
    CloseHandle(hDevice);
    hDevice := INVALID_HANDLE_VALUE;
  end;
end;

{------------------------------------------------------------------------------}

procedure SeekToPos(Pos: DWord);
begin
  if hDevice <> INVALID_HANDLE_VALUE then
    SetFilePointer(hDevice, Pos, NIL, FILE_BEGIN);
end;

{------------------------------------------------------------------------------}

function ReadSector(var Buffer: TSector): Boolean;
var BytesWritten: DWord;
begin
  Result := False;
  if hDevice <> INVALID_HANDLE_VALUE then
    Result := ReadFile(hDevice, Buffer, SizeOf(Buffer), BytesWritten, NIL);
end;

{------------------------------------------------------------------------------}

function WriteSector(var Buffer: TSector): Boolean;
var BytesWritten: DWord;
begin
  Result := False;
  if hDevice <> INVALID_HANDLE_VALUE then
    Result := WriteFile(hDevice, Buffer, SizeOf(Buffer), BytesWritten, NIL);
end;

{------------------------------------------------------------------------------}

function FormatTracks(MediaTyp: Cardinal; StartCylinder, EndCylinder, StartHead, EndHead: DWord): Boolean;
var BytesWritten: DWord;
    FormatParameters: TFormatParameters;
begin
  Result := False;
  if hDevice <> INVALID_HANDLE_VALUE then begin
    with FormatParameters do begin
      MediaType := MediaTyp;
      StartCylinderNumber := StartCylinder;
      EndCylinderNumber := EndCylinder;
      StartHeadNumber := StartHead;
      EndHeadNumber := EndHead;
    end;
    Result := DeviceIoControl(hDevice, IOCTL_Disk_Format_Tracks, @FormatParameters, SizeOf(FormatParameters), NIL, 0, BytesWritten, NIL);
  end;
end;

{------------------------------------------------------------------------------}

function GetDriveGeometry(var DiskGeometry: TDiskGeometry): Boolean;
var BytesWritten: Cardinal;
begin
  Result := False;
  if hDevice <> INVALID_HANDLE_VALUE then
    Result := DeviceIoControl(hDevice, IOCTL_DISK_GET_DRIVE_GEOMETRY, NIL, 0, Addr(DiskGeometry), SizeOf(DiskGeometry), BytesWritten, NIL);
end;

{------------------------------------------------------------------------------}

function GetLastErrorStr: String;
var MessageBuffer: Array[0..255] of Char;
begin
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NIL, GetLastError, 0, MessageBuffer, SizeOf(MessageBuffer), NIL);
  Result := MessageBuffer;
end;

{------------------------------------------------------------------------------}

function MediaTypeToStr(MediaType: LongInt): String;
begin
  case MediaType of
    F5_1Pt2_512: Result := 'Diskette 5.25" , 1.2 MB , 512 Bytes/Sector';
    F3_1Pt44_512: Result := 'Diskette 3.5" , 1.44 MB , 512 Bytes/Sector';
    F3_2Pt88_512: Result := 'Diskette 3.5" , 2.88 MB , 512 Bytes/Sector';
    F3_20Pt8_512: Result := 'Diskette 3.5" , 20.8 MB , 512 Bytes/Sector';
    F3_720_512: Result := 'Diskette 3.5" , 720 KB , 512 Bytes/Sector';
    F5_360_512: Result := 'Diskette 5.25" , 360 KB , 512 Bytes/Sector';
    F5_320_512: Result := 'Diskette 5.25" , 320 KB , 512 Bytes/Sector';
    F5_320_1024: Result := 'Diskette 5.25" , 320 KB , 1024 Bytes/Sector';
    F5_180_512: Result := 'Diskette 5.25" , 180 KB , 512 Bytes/Sector';
    F5_160_512: Result := 'Diskette 5.25" , 160 KB , 512 Bytes/Sector';
    RemovableMedia: Result := 'Wechselmedium';
    FixedMedia: Result := 'Festplatte';
  else
    Result := 'Unbekanntes Format';
  end;
end;

{------------------------------------------------------------------------------}

function DiskInDrive: Boolean;
var DiskGeometry: TDiskGeometry;
begin
  Result := GetDriveGeometry(DiskGeometry);
end;

{------------------------------------------------------------------------------}

function WaitForDisk: Boolean;
begin
  Result := True;
  if not DiskInDrive then
    repeat
      Result := SureDlg('Bitte eine Diskette einlegen ...');
    until DiskInDrive or not Result;
end;

{------------------------------------------------------------------------------}

function  ReadTrack(var Buffer: TTrack): Boolean;
var bDummy: Byte;
begin
  for bDummy := 1 to 18 do begin
    Result := ReadSector(Buffer[bDummy]);
    if not Result then
      Break;
  end;
end;

{------------------------------------------------------------------------------}

function  WriteTrack(var Buffer: TTrack): Boolean;
var bDummy: Byte;
begin
  for bDummy := 1 to 18 do begin
    Result := WriteSector(Buffer[bDummy]);
    if not Result then
      Break;
  end;
end;

{------------------------------------------------------------------------------}

end.
