{************************************************************************}
{*             $ Datum: 29.12.2000     Zeit: 23:44:50 $                 *}
{************************************************************************}

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ImgList, FileCtrl, Util, ExtCtrls, Buttons, ToolWin,
  {ExtStatusBar,} ekbview;

type
  TfrmMain = class(TForm)
    ToolBar1: TToolBar;
    Panel1: TPanel;
    ToolButton1: TToolButton;
    tbReadKeyDisk: TToolButton;
    tbSetKeyCount: TToolButton;
    tbDiskTools: TToolButton;
    lvFilesA: TListView;
    tbExitApp: TToolButton;
    lvFilesB: TListView;
    Label1: TLabel;
    Label2: TLabel;
    btnInstallOne: TButton;
    btnRemoveOne: TButton;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    flCall: TRadioButton;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure tbReadKeyDiskClick(Sender: TObject);
    procedure tbExitAppClick(Sender: TObject);
    procedure tbDiskToolsClick(Sender: TObject);
    procedure tbSetKeyCountClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnInstallOneClick(Sender: TObject);
    procedure btnRemoveOneClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    boActive: Boolean;
    AuthBuffer: Array[0..783] of Byte;
    procedure AddEkbFile(Drive: Char; ListView: TListView; FileName: String);
    procedure CollectFiles(Drive: Char; ListView: TListView);
    function GetKeyImageIndex(Drive: Char): Byte;
    function  ResetKeyCount(EkbName: String): Boolean;
    procedure CopyText(Start: Byte; Text: String);
    procedure GetEkbData(Drive: Char; FileName: String);
    procedure InstallKey(SourceDrive, DestDrive: Char; EkbName: String);
    procedure RemoveKey(SourceDrive, DestDrive: Char; EkbName: String);
    function GetKeyCount(Drive: Char): Byte;
  public
  end;

function VERPROT32CALL(var PAuthBuffer): Integer; stdcall; external 'scpw32.dll' name 'VERPROT32CALL';
function SCPBATWDO32CALL(var PAuthBuffer): Integer; stdcall; external 'scpbw32.dll' name 'SCPBATWDO32CALL';
var
 frmMain: TfrmMain;
 bMaskN:byte;
 data, data1:array [0..2559] of byte;
 fCallWork:boolean;

implementation

uses DM_Main, DiskUtil, DiskUtilForm, ProgressForm;

{$R *.DFM}

{*** Globale Programmkonstanten *************************************************}

resourcestring
  AuthDir = 'AX NF ZZ';
  AuthExt = '.EKB';

const
  AuthDriveA: Char = 'A';
  AuthDriveB: Char = 'C';

{*** TMainForm ******************************************************************}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Caption := GetProductName + rsSpace5 + rsVersion + GetFileVersion + rsSpace5 + GetLegalCopyRight;

end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  //
end;

{--------------------------------------------------------------------------------}

function TfrmMain.ResetKeyCount(EkbName: String): Boolean;
var hFile: THandle;
    bData: Byte;
    BytesWritten: Cardinal;
    iDummy: Integer;
    boAdjust: Boolean;
begin
  Result := True;
(*
  FillChar(AuthBuffer, SizeOf(AuthBuffer), 0);
  AuthBuffer[0] := 1;
  AuthBuffer[7] := 1;
  AuthBuffer[8] := 10;
  CopyText(18, Copy(EkbName, 0, Length(EkbName)));
  AuthBuffer[111] := 0;
  CopyText(18, '????');
  VerProt32Call(AuthBuffer);
*)
  hFile := CreateFile(PChar(EkbName), GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  try
    if (hFile <> INVALID_HANDLE_VALUE) then begin
      SetFilePointer(hFile, $0A, NIL, FILE_BEGIN );
      ReadFile(hFile, bData,1, BytesWritten, NIL);
      if(bData = $06 ) then begin
        bData := $07;
        boAdjust := False;
	SetFilePointer(hFile, $0A, NIL, FILE_BEGIN);
	WriteFile(hFile, bData, 1, BytesWritten, NIL);
	SetFilePointer(hFile, $313, NIL, FILE_BEGIN);
	ReadFile(hFile, bData, 1, BytesWritten, NIL);
	iDummy := bData mod $10;
        case iDummy of
	  $00: ;
	  $08: begin
                 Inc(bData, $0F);
                 boAdjust := True;
               end;
          else
            Dec(bData);
        end;
	SetFilePointer(hFile, $313, NIL, FILE_BEGIN);
        WriteFile(hFile, bData, 1, BytesWritten, NIL);
	if boAdjust then begin
          SetFilePointer(hFile, $4FE, NIL, FILE_BEGIN);
          ReadFile(hFile, bData, 1, BytesWritten, NIL);
          Inc(bData, $10);
          SetFilePointer( hFile, $4FE, NIL, FILE_BEGIN);
          WriteFile(hFile, bData, 1, BytesWritten, NIL);
	end;
      end;
    end;
  finally
    CloseHandle(hFile);
  end;
end;

{--------------------------------------------------------------------------------}

function TfrmMain.GetKeyImageIndex(Drive: Char): Byte;
begin
  Result := 4;
  if (Drive = 'A') and
  ((flCall.Checked and (AuthBuffer[8] > 0)) or ((flCall.Checked=false) and (rEKBdata.by[$0A]>0)))
   then
    Result := 3
  else if (Drive = 'C') and
  ((flCall.Checked and (AuthBuffer[9] > 0)) or ((flCall.Checked=false) and (rEKBdata.by[$0A]>0)))
  then
    Result := 5;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.CopyText(Start: Byte; Text: String);
var bDummy: Byte;
begin
  for bDummy := 1 to Length(Text) do
    AuthBuffer[Start - 1 + bDummy] := (Ord(Text[bDummy]));
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.GetEkbData(Drive: Char; FileName: String);
  var s,s1,s2,s3,fnAX, BackupName :string;
i,j,k,m,n:integer;
 buf: TStream;
 w:word;
 fl:boolean;
 b:byte;
 nd:char;
begin
  FillChar(AuthBuffer, SizeOf(AuthBuffer), 0);
  AuthBuffer[0] := 5;
  AuthBuffer[7] := 0;
  AuthBuffer[16] := Ord(Drive) - Ord('@');
  AuthBuffer[47] := 2;
  CopyText(18, Copy(FileName, 0, Length(FileName) - 4));
//  CopyText(18, Copy(FileName, 0, Length(FileName)));
  AuthBuffer[111] := 1;
  VerProt32Call(AuthBuffer);
  i:=1;
 if (Filename<>'SCP126C.EKB') and (Filename<>'SCP200A.EKB') and(Filename<>'SCP300A.EKB')
  and  (Filename<>'SIFLA171040503.ekb')
  and (Filename<>'SIFLS7PROF0503.ekb')
 then
 begin
  buf:= TFileStream.Create(Filename , fmOpenRead);
  buf.Read(rEKBdata.by, 1280);
  buf.Free;
  pEKBumCodieren;
  EKB_info.Name:=fBezeichung;
  EKB_info.SerNum:=fNummer;
  EKB_info.CountInst:=rEKBdata.by[$0A];
  EKB_info.CountTotal:=rEKBdata.by[$0C];
 end           
 else
  begin
  if Filename='SIFLS7PROF0503.ekb' then EKB_info.Name:='Step 7 Professional Edition 2004'
  else if Filename='SIFLA171040503.ekb' then EKB_info.Name:='Step 7-BASIS V5.3 '
  else EKB_info.Name:='Template';
  EKB_info.SerNum:='???';
  EKB_info.CountInst:=0;
  EKB_info.CountTotal:=0;
 end;
  { edTranzNum.Text:=IntToStr(rEKBdata.by[$313]);
   edTranzDate.Text:=chr(rEKBdata.by[$30b])+chr(rEKBdata.by[$30c])+'/'+
   chr(rEKBdata.by[$30d])+chr(rEKBdata.by[$30e])+'/'+
   chr(rEKBdata.by[$30F])+chr(rEKBdata.by[$310])+
   chr(rEKBdata.by[$311])+chr(rEKBdata.by[$312]);
   }
end;
{--------------------------------------------------------------------------------}

procedure TfrmMain.InstallKey(SourceDrive, DestDrive: Char; EkbName: String);
begin
  FillChar(AuthBuffer, SizeOf(AuthBuffer), 0);
  AuthBuffer[0] := 0;
  AuthBuffer[5] := Ord(SourceDrive);
  AuthBuffer[6] := Ord(DestDrive);
  CopyText(16, Copy(EkbName, 0, Length(EkbName)));
  SCPBATWDO32CALL(AuthBuffer);
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.RemoveKey(SourceDrive, DestDrive: Char; EkbName: String);
begin
  FillChar(AuthBuffer, SizeOf(AuthBuffer), 0);
  AuthBuffer[0] := 1;
  AuthBuffer[5] := Ord(SourceDrive);
  AuthBuffer[6] := Ord(DestDrive);
  CopyText(16, Copy(EkbName, 0, Length(EkbName)));
  SCPBATWDO32CALL(AuthBuffer);
end;

{--------------------------------------------------------------------------------}

function TfrmMain.GetKeyCount(Drive: Char): Byte;
begin
  if (Drive = 'A')
   then
    begin
    if flCall.Checked then Result := AuthBuffer[8]
                           else Result := EKB_info.CountInst;
    end
  else
   begin
    if flCall.Checked then Result := AuthBuffer[9]
                           else Result := EKB_info.CountInst;
   end;                        
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.AddEkbFile(Drive: Char; ListView: TListView; FileName: String);
var NewListItem: TListItem;
    acDummy: Array[0..255] of Char;
begin
 GetEkbData(Drive, FileName);
 if (Ord(AuthBuffer[1]) = $FF)
  then with ListView do
     begin
      NewListItem := Items.Add;
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[145], acDummy, 95);
      NewListItem.Caption := acDummy;
      NewListItem.ImageIndex := GetKeyImageIndex(Drive);
      NewListItem.SubItems.Add(IntToStr(GetKeyCount(Drive)));
      NewListItem.SubItems.Add('????');
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[18], acDummy, 10);
      NewListItem.SubItems.Add(acDummy);
      NewListItem.SubItems.Add('?');
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[48], acDummy, 10);
      NewListItem.SubItems.Add(acDummy);
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[247], acDummy, 2);
      NewListItem.SubItems.Add(acDummy);
      flCall.Checked:=true;
    end
  else with ListView do
   begin
      NewListItem := Items.Add;
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[145], acDummy, 95);
      NewListItem.Caption := EKB_info.Name;
      NewListItem.ImageIndex := GetKeyImageIndex(Drive);
      NewListItem.SubItems.Add(IntToStr(GetKeyCount(Drive)));
      NewListItem.SubItems.Add('????');
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[18], acDummy, 10);
      NewListItem.SubItems.Add(acDummy);
      NewListItem.SubItems.Add('?');
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[48], acDummy, 10);
      NewListItem.SubItems.Add(EKB_info.SerNum);
      FillChar(acDummy, SizeOf(acDummy), 0);
      Move(AuthBuffer[247], acDummy, 2);
      NewListItem.SubItems.Add(acDummy);
   end;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.CollectFiles(Drive: Char; ListView: TListView);
var SearchRecord: TSearchRec;
    wOldErrorMode: Word;
    wFileCount: Word;
    wAktCount: Word;
begin
  if not boActive then begin
    boActive := True;
    wfileCount := 0;
    ListView.SortType := stNone;
    with ListView.Items do begin
      BeginUpdate;
      Clear;
      EndUpdate;
    end;
    wOldErrorMode := SetErrorMode(SEM_FailCriticalErrors);
    if DirectoryExists(Drive + ':\' + AuthDir) then begin
      ChDir(Drive + ':\' + AuthDir);
      if IOResult = 0 then begin
        SetErrorMode(wOldErrorMode);
        if FindFirst('*' + AuthExt, faHidden or faSysFile, SearchRecord) = 0 then begin
          Inc(wFileCount);
          while FindNext(SearchRecord) = 0 do
            Inc(wFileCount);
        end;
        frmProgress := TfrmProgress.Create(Self);
        try
          frmProgress.Left := (Left + (Width div 2)) - (frmProgress.Width div 2);
          frmProgress.Top := (Top + (Height div 2)) - (frmProgress.Height div 2);
          with frmProgress do begin
            Show;
            wAktCount := 0;
            if FindFirst('*' + AuthExt, faHidden or faSysFile, SearchRecord) = 0 then begin
              AddEkbFile(Drive, ListView, SearchRecord.Name);
              Inc(wAktCount);
              ProgressBar.Position := Round(wAktCount * 100 / wFileCount);
              lblProzent.Caption := IntToStr(ProgressBar.Position) + '%';
              Application.ProcessMessages;
              while FindNext(SearchRecord) = 0 do begin
                AddEkbFile(Drive, ListView, SearchRecord.Name);
                Inc(wAktCount);
                ProgressBar.Position := Round(wAktCount * 100 / wFileCount);
                lblProzent.Caption := IntToStr(ProgressBar.Position) + '%';
                Application.ProcessMessages;
              end;
            end;
            FindClose(SearchRecord);
          end;
        finally
          frmProgress.Free;
        end;
      end;
    end;
    SetErrorMode(wOldErrorMode);
    ListView.SortType := stText;
    if ListView.Items.Count > 0 then
      ListView.TopItem.Selected := True;
  end;
  boActive := False;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.tbReadKeyDiskClick(Sender: TObject);
begin
  CollectFiles(AuthDriveA, lvFilesA);
  CollectFiles(AuthDriveB, lvFilesB);
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.tbExitAppClick(Sender: TObject);
begin
  if not boActive then
    Close;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.tbDiskToolsClick(Sender: TObject);
begin
  if GetOsTypInfo = 'Windows NT' then begin
    if not boActive then begin
      frmDiskTools := TfrmDiskTools.Create(Self);
      try
        with frmDiskTools do begin
          ShowModal;
          Hide;
          if boKeyPressed then begin
            CollectFiles(AuthDriveA, lvFilesA);
            CollectFiles(AuthDriveB, lvFilesB);
          end;
        end;
      finally
        frmDiskTools.Free;
      end;
    end;
  end else
    InfoDlg('  Momentan ist diese Funktion nur' + #10#13 +
            'fr Windows NT/2K implementiert !!!');
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.tbSetKeyCountClick(Sender: TObject);
begin
  if not boActive then begin
    if lvFilesA.SelCount > 0 then begin
      ResetKeyCount('A:\' + AuthDir + '\' + lvFilesA.Selected.SubItems.Strings[2] + AuthExt);
      CollectFiles(AuthDriveA, lvFilesA);
      CollectFiles(AuthDriveB, lvFilesB);
    end;
  end;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.btnInstallOneClick(Sender: TObject);
begin
  if lvFilesA.SelCount > 0 then begin
    InstallKey(AuthDriveA, AuthDriveB, lvFilesA.Selected.SubItems.Strings[2]);
    CollectFiles(AuthDriveA, lvFilesA);
    CollectFiles(AuthDriveB, lvFilesB);
  end;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.btnRemoveOneClick(Sender: TObject);
begin
  if lvFilesB.SelCount > 0 then begin
    RemoveKey(AuthDriveB, AuthDriveA, lvFilesB.Selected.SubItems.Strings[2]);
    CollectFiles(AuthDriveA, lvFilesA);
    CollectFiles(AuthDriveB, lvFilesB);
  end;
end;

{--------------------------------------------------------------------------------}

procedure TfrmMain.Button1Click(Sender: TObject);
var hFile,hFile1: THandle;
    bData1: array [0..1279] of Byte;
    BytesWritten: Cardinal;
    iDummy: Integer;
    boAdjust: Boolean;
    EkbName:string;
    adr:integer;
begin
  
(*
  FillChar(AuthBuffer, SizeOf(AuthBuffer), 0);
  AuthBuffer[0] := 1;
  AuthBuffer[7] := 1;
  AuthBuffer[8] := 10;
  CopyText(18, Copy(EkbName, 0, Length(EkbName)));
  AuthBuffer[111] := 0;
  CopyText(18, '????');
  VerProt32Call(AuthBuffer);
*)
EkbName:='c:\DISK.BIN';
  hFile := CreateFile(PChar(EkbName), GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
      EkbName:='c:\DISK.ekb';
  hFile1 := CreateFile(PChar(EkbName), GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  try
    if (hFile <> INVALID_HANDLE_VALUE) then begin
      SetFilePointer(hFile, $b000, NIL, FILE_BEGIN );
      ReadFile(hFile, bData1,1280, BytesWritten, NIL);

  SetFilePointer(hFile1, $0, NIL, FILE_BEGIN );
	WriteFile(hFile1, bData1, 1280, BytesWritten, NIL);
  end;
  finally
    CloseHandle(hFile);
    CloseHandle(hFile1);
  end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
var i:integer;
begin
i:=0;
  CollectFiles(AuthDriveB, lvFilesB);

end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
    if OpenDevice('A') then
      if WaitForDisk then

FormatTracks($05 , 78, 78, 1, 1);     //F3_720_512
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
    if OpenDevice('A') then
      if WaitForDisk then

FormatTracks($05 , 71, 71, 1, 1);     //F3_720_512

end;

end.

