{************************************************************************}
{*             $ Datum: 26.12.2000     Zeit: 16:44:45 $                 *}
{************************************************************************}

unit Util;

{------------------------------------------------------------------------------}

interface

{------------------------------------------------------------------------------}

uses Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
     StdCtrls, Registry, Graphics, ExtCtrls, ImageHlp,variants;

{------------------------------------------------------------------------------}

ResourceString
  rsSpace2       = '  ';
  rsSpace5       = '     ';
  rsSpace10      = '          ';
  rsVersion      = 'Version : ';
  rsProgrammInfo = 'Programminformation';

{------------------------------------------------------------------------------}

const Typ_Byte             = 0;
      Typ_KB               = 1;
      Typ_MB               = 2;

      GFSR_SYSTEMRESOURCES = 0;
      GFSR_GDIRESOURCES    = 1;
      GFSR_USERRESOURCES   = 2;

      PROCESSOR_ARCHITECTURE_INTEL = 0;
      PROCESSOR_ARCHITECTURE_MIPS = 1;
      PROCESSOR_ARCHITECTURE_ALPHA = 2;
      PROCESSOR_ARCHITECTURE_PPC = 3;

      CPUIDF_FPU  = 1 shl 0;  {  Floating-point unit on-chip  }
      CPUIDF_VME  = 1 shl 1;  {  Virtual Mode Extension  }
      CPUIDF_DE   = 1 shl 2;  {  Debugging Extension  }
      CPUIDF_PSE  = 1 shl 3;  {  Page Size Extension  }
      CPUIDF_TSC  = 1 shl 4;  {  Time Stamp Counter  }
      CPUIDF_MSR  = 1 shl 5;  {  Mode Spacific Registers  }
      CPUIDF_PAE  = 1 shl 6;  {  Physical Address Extension  }
      CPUIDF_MCE  = 1 shl 7;  {  Machine Check Exception  }
      CPUIDF_CX8  = 1 shl 8;  {  CMPXCHG8 Instruction Supported  }
      CPUIDF_APIC = 1 shl 9;  {  On-chip APIC Hardware Supported }
      CPUIDF_MTRR = 1 shl 12; {  Memory Type Range Registers  }
      CPUIDF_PGE  = 1 shl 13; {  Page Global Enable  }
      CPUIDF_MCA  = 1 shl 14; {  Machine Check Architecture  }
      CPUIDF_CMOV = 1 shl 15; {  Conditional Move Instruction Supported  }
      CPUIDF_MMX  = 1 shl 23; {  Intel Architecture MMX Technology supported  }

{------------------------------------------------------------------------------}

var   bParamCount_u        : Byte;
      asParamStr_u         : Array[1..30] of String[80];
      CPUIDVendor          : Array[0..12] of Char;
      CPUIDSignature       : DWord;
      CPUIDFeatures        : DWord;

{------------------------------------------------------------------------------}

function  IsSoftIceNTLoaded: boolean;
function  IsSoftIce95Loaded: boolean;
function  AddBkSlash (S : string) : string;
function  RemBkSlash (S : string) : string;
function  CheckDelphi : Byte;
function  IsDelphiRunning : boolean;
function  GetCpuSpeed: String;
function  GetEnvVar(VarName: String): String;
function  GetMaxMemInfo(Typ : Byte) : String;
function  GetAktMemInfo(Typ : Byte) : String;
function  GetOSTypInfo : String;
function  GetOSVersionInfo : String;
function  GetOSBuildInfo : String;
function  GetOSSubVersionInfo : String;
function  GetSystemResourceInfo : String;
function  GetUserResourceInfo : String;
function  GetGDIResourceInfo : String;
function  GetLocalUserName : String;
function  GetLocalCompanyName : String;
function  GetProcessorType : String;
function  GetFromRegistry (RootKey : HKEY; Localkey, Field : String; VarDummy : Variant) : Variant;
function  GetFreeSystemResources(Art : Word) : Word; StdCall;
function  StrBetween(SIn, sLeft, sRight : String) : String;
function  StrContains(S1, S2: String) : Boolean;
function  TrimmLeft(Text : String) : String;
function  TrimmRight(Text : String) : String;
function  TrimmBoth(Text : String) : String;
function  RightStr(Text :String; Laenge : Word) :String;
function  LeftStr(Text :String; Laenge : Word) : String;
function  Min(Wert1 , Wert2 : Variant) : Variant;
function  Max(Wert1, Wert2 : Variant) : Variant;
function  DateToWeekNumber(Date : TDateTime): Byte;
function  SureDlg(sText : String) : Boolean;
function  IsAppRunning(Name: PChar) : Boolean;
function  GetCompanyName: String;
function  GetFileDescription: String;
function  GetFileVersion: String;
function  GetInternalName: String;
function  GetLegalCopyright: String;
function  GetLegalTradeMarks: String;
function  GetOriginalFileName: String;
function  GetProductName: String;
function  GetProductVersion: String;
function  GetComments: String;
function  GetMailURL: String;
function  GetWebURL: String;
function  HexToInt(HexWert: String): LongInt;
function  GetWinDir: String;
function  GetSysDir: String;
function  CryptStr(InStr: String): String;

procedure Delay(MSec: LongInt);
procedure GetZeile(sParam : String);
procedure SaveInRegistry (RootKey : HKEY; Localkey, Field : String; VarDummy : Variant);
procedure InfoDlg(sText : String);
procedure WarnDlg(sText : String);
procedure ExitWindows32(ShutDownFlag: Word);

{------------------------------------------------------------------------------}

implementation

{------------------------------------------------------------------------------}

procedure ExitWindows32(ShutDownFlag: Word);
  function ChangeNTSecurityForShutdown: Boolean;
  var
    hToken : THandle;
    tkp,
    Newt   : TTokenPrivileges;
    retlength : DWORD;
  begin
      Result := False;
      if OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES +
                          TOKEN_QUERY, hToken) <> False then
        begin
           if LookupPrivilegeValue( nil, 'SeShutdownPrivilege',
                                    tkp.Privileges[0].Luid) = True then
             begin
               tkp.PrivilegeCount := 1;
               tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
               Result := AdjustTokenPrivileges(hToken, False, tkp,
                                               SizeOf(TTokenPrivileges), Newt,
                                               retlength);
             end;
        end;
  end;

begin
  if GetOsTypInfo = 'Windows NT' then
    begin
      if ChangeNTSecurityForShutdown then
        ExitWindowsEx(ShutDownFlag, 0)
      else
        { Failed to change security rights to give us shutdown privilege. }
        MessageDlg('Unable to modify security rights for shutdown privileges.', mtError, [mbOK], 0);
    end
  else
    ExitWindowsEx(ShutDownFlag, 0);
end;

{------------------------------------------------------------------------------}

procedure Delay(MSec: LongInt);
var
  Start, Stop: LongInt;
begin
  Start := GetTickCount;
  repeat
  Stop := GetTickCount;
  Application.ProcessMessages;
  until (Stop - Start ) >= MSec;
end;

{------------------------------------------------------------------------------}

function GetWinDir: String;
var
  dir: array [0..max_path] of char;
begin
 GetWindowsDirectory(dir, max_path);
 result:=StrPas(dir);
end;

{------------------------------------------------------------------------------}

function GetSysDir: String;
var
  dir: array [0..max_path] of char;
begin
 GetSystemDirectory(dir, max_path);
 result:=StrPas(dir);
end;

{------------------------------------------------------------------------------}

const RSRC32DLL      = 'RSRC32.DLL';
var   OsVersionInfo  : TOsVersionInfo;
      RegIniFile     : TRegIniFile;

{------------------------------------------------------------------------------}

function HexToInt(HexWert: String): LongInt;
begin
  if Length(HexWert) = 0 then
    Result := 0
  else
    Result := StrToInt('$' + HexWert);
end;

{------------------------------------------------------------------------------}

function CryptStr(InStr: String): String;
var s : string[255];
    c : array[0..255] of byte absolute s;
    i : Integer;
begin
  s := InStr;
  for i := 1 To ord(s[0]) do
    c[i] :=  c[i] xor $55;
  Result := s;
end;

{------------------------------------------------------------------------------}

function IsSoftIce95Loaded: boolean;
var hFile: Thandle;
begin
  result := false;
  hFile := CreateFileA(PChar(CryptStr('		{	')) {'\\.\SICE'}, GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if( hFile <> INVALID_HANDLE_VALUE ) then begin
    CloseHandle(hFile);
    result := True;
  end;
end;

function IsSoftIceNTLoaded: boolean;
var hFile: Thandle;
begin
  result := false;
  hFile := CreateFileA(PChar(CryptStr('		{	')) {'\\.\NTICE'}, GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if( hFile <> INVALID_HANDLE_VALUE ) then begin
    CloseHandle(hFile);
    result := True;
  end;
end;

function GetFileInfoStr(IdxStr: String) : String;
var
  sDummy     : String;
  Buffer     : PChar;
  Value      : PChar;
  Len        : DWord;
  BufferSize : DWord;
begin
  Result := '';
  sDummy := Application.ExeName;
  BufferSize := GetFileVersionInfoSize(PChar(sDummy), BufferSize);
  if BufferSize > 0 then begin
    Buffer := AllocMem(BufferSize);
    try
      GetFileVersionInfo(PChar(sDummy),0, BufferSize, Buffer);
      if VerQueryValue(Buffer, PChar('StringFileInfo\040704E4\' + IdxStr), Pointer(Value), Len) then
        Result := Value;
    finally
      FreeMem(Buffer, BufferSize);
    end;
  end;
end;

{------------------------------------------------------------------------------}

function GetCompanyName: String;
begin
  Result := GetFileInfoStr('CompanyName');
end;

{------------------------------------------------------------------------------}

function GetFileDescription: String;
begin
  Result := GetFileInfoStr('FileDescription');
end;

{------------------------------------------------------------------------------}

function GetFileVersion: String;
begin
  Result := GetFileInfoStr('FileVersion');
end;

{------------------------------------------------------------------------------}

function GetInternalName: String;
begin
  Result := GetFileInfoStr('InternalName');
end;

{------------------------------------------------------------------------------}

function GetLegalCopyright: String;
begin
  Result := GetFileInfoStr('LegalCopyright');
end;

{------------------------------------------------------------------------------}

function GetLegalTradeMarks: String;
begin
  Result := GetFileInfoStr('LegalTradeMarks');
end;

{------------------------------------------------------------------------------}

function GetOriginalFileName: String;
begin
  Result := GetFileInfoStr('OriginalFileName');
end;

{------------------------------------------------------------------------------}

function GetProductName: String;
begin
  Result := GetFileInfoStr('ProductName');
end;

{------------------------------------------------------------------------------}

function GetProductVersion: String;
begin
  Result := GetFileInfoStr('ProductVersion');
end;

{------------------------------------------------------------------------------}

function GetComments: String;
begin
  Result := GetFileInfoStr('Comments');
end;

{------------------------------------------------------------------------------}

function GetMailURL: String;
begin
  Result := GetFileInfoStr('Mail-URL');
end;

{------------------------------------------------------------------------------}

function GetWebURL: String;
begin
  Result := GetFileInfoStr('WEB-URL');
end;

{------------------------------------------------------------------------------}

function AddBkSlash (S : string) : string;
begin
  if (S = '') or (S[Length(S)] = '\') then
    Result:=S
  else
    Result:=S + '\';
end;

{------------------------------------------------------------------------------}

function RemBkSlash (S : string) : string;
begin
  if (S <> '') and (S[Length(S)] = '\') then
    Result:=Copy(S, 1, Length(S) - 1)
  else
    Result:=S;
end;

{------------------------------------------------------------------------------}

function CheckDelphi : Byte;
begin
  if (FindWindow('TApplication', 'Delphi 1.0') <> 0) then
    Result := 1
  else if (FindWindow('TApplication', 'Delphi 2.0') <> 0) then
    Result := 2
  else if (FindWindow('TApplication', 'Delphi 3') <> 0) then
    Result := 3
  else if (FindWindow('TApplication', 'Delphi 4') <> 0) then
    Result := 4
  else if (FindWindow('TApplication', 'Delphi 5') <> 0) then
    Result := 5
  else
    Result := 0;
end;

function IsDelphiRunning : boolean;
var
  H1, H3, H5,H6 : Hwnd;
const
  A1 : array[0..12] of char = 'TApplication'#0;
  A3 : array[0..18] of char = 'TPropertyInspector'#0;
  A4 : array[0..11] of char = 'TAppBuilder'#0;
  T1 : array[0..8] of char = 'Delphi 3'#0;
  T2 : array[0..8] of char = 'Delphi 4'#0;
  T3 : array[0..8] of char = 'Delphi 5'#0;
begin
  H1 := FindWindow(A1, T1);
  H3 := FindWindow(A3, nil);
  H5 := FindWindow(A1, T2);
  H6 := FindWindow(A1, T3);
  Result := ((H1 <> 0) or (H5 <> 0) or (H6 <> 0)) and (H3 <> 0);
end;

{------------------------------------------------------------------------------}

function GetCpuSpeed: String;
var
  t: DWORD;
  mhi, mlo, nhi, nlo: LongInt;
  t0, t1, chi, clo, shr32: Comp;
begin
  shr32 := 65536;
  shr32 := shr32 * 65536;
  t := GetTickCount;
  while t = GetTickCount do begin
  end;
  asm
    DB 0FH
    DB 31H
    mov mhi,edx
    mov mlo,eax
  end;
  while GetTickCount < (t + 1000) do begin
  end;
  asm
    DB 0FH
    DB 31H
    mov nhi,edx
    mov nlo,eax
  end;
  chi := mhi;
  if mhi < 0 then
    chi := chi + shr32;
  clo := mlo;
  if mlo < 0 then
    clo := clo + shr32;
  t0 := chi * shr32 + clo;
  chi := nhi;
  if nhi < 0 then
    chi := chi + shr32;
  clo := nlo;
  if nlo < 0 then
    clo := clo + shr32;
  t1 := chi * shr32 + clo;
  Result := Format('%.0f MHz', [((t1 - t0) / 1E6)]);
end;

{------------------------------------------------------------------------------}

function GetFreeSystemResources; external RSRC32DLL name '_MyGetFreeSystemResources32@4';

{------------------------------------------------------------------------------}

function DateToWeekNumber(Date : TDateTime): Byte;
var
  Y, M, D:Word;
  dtTmp: TDateTime;
begin
  DecodeDate(Date, Y, M, D);
  dtTmp:=EnCodeDate(Y, 1, 1);
  Result:=(Trunc(Date - dtTmp) + (DayOfWeek(dtTmp) -1 )) DIV 7;
  if Result = 0 then
    Result := 51
  else
    Result:= Result - 1;
end;

{------------------------------------------------------------------------------}

function Min(Wert1 , Wert2 : Variant) : Variant;
begin
  if Wert1 < Wert2 then
    Result := Wert1
  else
    Result := Wert2;
end;

{------------------------------------------------------------------------------}

function Max(Wert1, Wert2 : Variant) : Variant;
begin
  if Wert1 > Wert2 then
    Result := Wert1
  else
    Result := Wert2;
end;
{------------------------------------------------------------------------------}

function RightStr(Text : String; Laenge : Word) : String;
begin
  if Laenge > Length(Text) then
    Result := Text
  else
    Result := Copy(Text, Length(text) - Laenge + 1, Length(text));
end;

{------------------------------------------------------------------------------}

function LeftStr(Text : String; Laenge : Word) : String;
begin
  Result := Copy(Text, 1, Laenge);
end;

{------------------------------------------------------------------------------}

function TrimmLeft(Text : String) : String;
begin
  if Length(Text) > 0 then begin
    repeat
      if (Text[1] = ' ') or (Text[1] = #0) then
        Delete(Text, 1, 1)
    until (Text[1] <> ' ') or (Length(Text) = 0);
  end;
  Result := Text;
end;

{-----------------------------------------------}

function TrimmRight(Text : String) : String;
var bL   : Byte;
begin
  bL := Length(Text);
  if bL > 0 then begin
    repeat
      if Text[bL] = ' ' then
        Delete(Text, bL, 1)
      else if Text[bL] = #0 then
        Text := LeftStr(Text, bL - 1);
      bL := Length(Text);
    until ((Text[bL] <> ' ') and (Text[bL] <> #0)) or (bL = 0);
  end;
  Result := Text;
end;

{------------------------------------------------------------------------------}

function TrimmBoth(Text : String) : String;
begin
  TrimmBoth := TrimmLeft(TrimmRight(Text));
end;

{------------------------------------------------------------------------------}

procedure GetZeile(sParam : String);
var  bParamLen             : Byte;
     bKPos                 : Byte;
     bKPos1                : Byte;
     bKPos2                : Byte;
     sOldParam             : String;
begin
  bParamCount_u := 0;
  FillChar(asParamStr_u, SizeOf(asParamStr_u), #0);
  sParam := TrimmBoth(sParam);
  repeat
    bParamLen := Length(sParam);
    sOldParam := sParam;
    if bParamLen > 0 then begin
      Inc(bParamCount_u);
      bKPos1 := Pos(',', sParam);
      bKPos2 := Pos(' ', sParam);
      bKPos := 0;
      if bKPos1 > 0 then
        bKPos := bKPos1;
      if bKPos2 > 0 then
        if bKPos > 0 then begin
          if bKPos2 < bKPos then
            bKPos := bKPos2;
        end else
          bKPos := bKPos2;
      if bKPos > 0 then begin
        asParamStr_u[bParamCount_u] := TrimmBoth(LeftStr(sParam, bKPos - 1));
        Delete(sParam, 1, bKPos);
        sParam := TrimmBoth(sParam);
      end else
        asParamStr_u[bParamCount_u] := sParam;
    end;
  until (bParamLen = 0) or (sOldParam = sParam) or (bParamCount_u > 29);
end;

{------------------------------------------------------------------------------}

function StrBetween(SIn, sLeft, sRight : String) : String;
var i1, i2 : Integer;
begin
  i1 := Pos(sLeft, SIn);
  Result := Copy(SIn, i1 + Length(sLeft), Length(SIn) - 1);
  i2 := Pos(sRight, Result );
  Result := Copy(Result, 1, i2 - 1);
end;

{------------------------------------------------------------------------------}

function StrContains(S1, S2: String) : Boolean;
begin
  Result := Pos(S2, S1) > 0;
end;

{------------------------------------------------------------------------------}

procedure ReadCPUID; assembler;
asm
  mov byte  ptr [CPUIDVendor], $00
  push ebx
  pushfd
  pop eax
  mov ecx,eax
  xor eax,$200000
  push eax
  popfd
  pushfd
  pop eax
  xor eax,ecx
  jz @@exit
  mov eax,0
  db $0F,$A2
  cmp eax,1
  jl @@exit
  mov eax,0
  db $0F,$A2
  mov dword ptr [CPUIDVendor], ebx
  mov dword ptr [CPUIDVendor+4], edx
  mov dword ptr [CPUIDVendor+8], ecx
  mov byte  ptr [CPUIDVendor+12], $00
  mov eax,1
  db $0F,$A2
  mov CPUIDSignature,eax
  mov CPUIDFeatures,edx
@@exit:
  pop ebx
end;

{------------------------------------------------------------------------------}

function GetProcessorType : String;
var   SystemInfo : TSystemInfo;
begin
  GetSystemInfo(SystemInfo);
  case SystemInfo.wProcessorArchitecture of
    PROCESSOR_ARCHITECTURE_INTEL :  begin
                                      ReadCPUID;
                                      if CPUIDVendor[0] <> #0 then
                                        Result := StrPas(CPUIDVendor)
                                      else
                                        Result := 'INTEL';
                                      case SystemInfo.wProcessorLevel of
                                        3 : Result := Result + ' 80386';
                                        4 : Result := Result + ' 80486';
                                        5 : Result := Result + ' Pentium';
                                        6 : Result := Result + ' Pentium II';
                                        else Result := Result + ' Unbekannt';
                                      end;
                                      if (CPUIDFeatures and CPUIDF_MMX = CPUIDF_MMX) then
                                        Result := Result + '  MMX';
                                    end;
    PROCESSOR_ARCHITECTURE_MIPS :   begin
                                      Result := 'MIPS ';
                                      case SystemInfo.wProcessorLevel of
                                        4 : Result := Result + 'R4000';
                                        else Result := Result + 'Unbekannt';
                                      end;
                                    end;
    PROCESSOR_ARCHITECTURE_ALPHA :  Result := 'ALPHA ' + IntToStr(SystemInfo.wProcessorLevel);
    PROCESSOR_ARCHITECTURE_PPC :    begin
                                      Result := 'PPC ';
                                      case SystemInfo.wProcessorLevel of
                                         1 : Result := Result + '601';
                                         3 : Result := Result + '603';
                                         4 : Result := Result + '604';
                                         6 : Result := Result + '603+';
                                         9 : Result := Result + '604+';
                                         20 : Result := Result + '620';
                                        else Result := Result + 'Unbekannt';
                                      end;
                                    end;
    else                            Result := 'Unbekannt';
  end;
end;

{------------------------------------------------------------------------------}

function GetSystemResourceInfo : String;
begin
   Result := IntToStr(GetFreeSystemResources(GFSR_SYSTEMRESOURCES)) + ' %';
end;

{------------------------------------------------------------------------------}

function GetUserResourceInfo : String;
begin
   Result := IntToStr(GetFreeSystemResources(GFSR_USERRESOURCES)) + ' %';
end;

{------------------------------------------------------------------------------}

function GetGDIResourceInfo : String;
begin
   Result := IntToStr(GetFreeSystemResources(GFSR_GDIRESOURCES)) + ' %';
end;

{------------------------------------------------------------------------------}

function CreateRegistryPath : String;
begin
  Result := 'Software\Microsoft\Windows';
  if GetOsTypInfo = 'Windows NT' then
    Result := Result + ' NT';
  Result := Result + '\CurrentVersion';
end;

{------------------------------------------------------------------------------}

function GetLocalUserName : String;
begin
  Result := GetFromRegistry(HKEY_LOCAL_MACHINE, CreateRegistryPath, 'RegisteredOwner', '')
end;

{------------------------------------------------------------------------------}

function GetLocalCompanyName : String;
begin
  Result := GetFromRegistry(HKEY_LOCAL_MACHINE, CreateRegistryPath, 'RegisteredOrganization', '');
end;

{------------------------------------------------------------------------------}

function GetOSTypInfo : String;
begin
  OsVersionInfo.dwOSVersionInfoSize  := SizeOf(TOsVersionInfo);
  GetVersionEx(OsVersionInfo);
  case OsVersionInfo.dwPlatformId of
    VER_PLATFORM_WIN32s        : Result := 'Windows 3.x';
    VER_PLATFORM_WIN32_WINDOWS : begin
                                   GetVersionEx(OsVersionInfo);
                                   if (OsVersionInfo.dwMajorVersion = 4) and
                                      (OsVersionInfo.dwMinorVersion > 9) then
                                     Result := 'Windows 98'
                                   else
                                     Result := 'Windows 95'
                                 end;
    VER_PLATFORM_WIN32_NT      : Result := 'Windows NT';
  end;
end;

{------------------------------------------------------------------------------}

function GetOSVersionInfo : String;
begin
  OsVersionInfo.dwOSVersionInfoSize  := SizeOf(TOsVersionInfo);
  GetVersionEx(OsVersionInfo);
  Result := IntToStr(OsVersionInfo.dwMajorVersion) + '.' +
            IntToStr(OsVersionInfo.dwMinorVersion);
end;

{------------------------------------------------------------------------------}

function GetOSBuildInfo : String;
begin
  OsVersionInfo.dwOSVersionInfoSize  := SizeOf(TOsVersionInfo);
  GetVersionEx(OsVersionInfo);
  Result := IntToStr(LoWord(OsVersionInfo.dwBuildNumber));
end;

{------------------------------------------------------------------------------}

function GetOSSubVersionInfo : String;
begin
  OsVersionInfo.dwOSVersionInfoSize  := SizeOf(TOsVersionInfo);
  GetVersionEx(OsVersionInfo);
  Result := StrPas(OsVersionInfo.szCSDVersion);
end;

{------------------------------------------------------------------------------}

function GetEnvVar(VarName: String): String;
var
  pEnvRes: array[0..150] of Char;
  pEnvName: array[0..10] of Char;
begin
  Result := '';
  StrPCopy(pEnvName, VarName);
  if GetEnvironmentVariable(@pEnvName, @pEnvRes, 150) > 0 then
    Result := StrPas(pEnvRes);
end;

{------------------------------------------------------------------------------}

function GetMaxMemInfo(Typ : Byte) : String;
var MemoryStruct : TMemoryStatus;
begin
  MemoryStruct.dwLength := SizeOf(MemoryStruct);
  GlobalMemoryStatus(MemoryStruct);
  case Typ of
    Typ_Byte : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwTotalPhys)), ffNumber, 10, 0) + ' Bytes';
    Typ_KB   : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwTotalPhys div 1024)), ffNumber, 10, 0) + ' KB';
    Typ_MB   : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwTotalPhys div 1024 div 1024)), ffNumber, 10, 0) + ' MB';
  else
    Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwTotalPhys div 1024)), ffNumber, 10, 0) + ' KB';;
  end;
end;

{------------------------------------------------------------------------------}

function GetAktMemInfo(Typ : Byte) : String;
var MemoryStruct : TMemoryStatus;
begin
  MemoryStruct.dwLength := SizeOf(MemoryStruct);
  GlobalMemoryStatus(MemoryStruct);
  case Typ of
    Typ_Byte : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwAvailPhys)), ffNumber, 10, 0) + ' Bytes';
    Typ_KB   : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwAvailPhys div 1024)), ffNumber, 10, 0) + ' KB';
    Typ_MB   : Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwAvailPhys div 1024 div 1024)), ffNumber, 10, 0) + ' MB';
  else
    Result := FloatToStrF(StrToFloat(IntToStr(MemoryStruct.dwAvailPhys div 1024)), ffNumber, 10, 0) + ' KB';
  end;
end;

{------------------------------------------------------------------------------}

procedure SaveInRegistry(RootKey : HKEY; Localkey, Field : String; VarDummy : Variant);
begin
  ReginiFile := TRegIniFile.Create('');
  case RootKey of
    HKEY_CLASSES_ROOT,
    HKEY_CURRENT_USER,
    HKEY_LOCAL_MACHINE,
    HKEY_USERS,
    HKEY_PERFORMANCE_DATA,
    HKEY_CURRENT_CONFIG,
    HKEY_DYN_DATA : RegIniFile.RootKey := RootKey;
  end;
  with TRegistry(RegIniFile) do begin
    OpenKey(Localkey,true);
    case VarType(VarDummy) of
      VarByte     : WriteInteger (Field, VarDummy);
      VarNull     : WriteInteger (Field, VarDummy);
      VarInteger  : WriteInteger (Field, VarDummy);
      VarSmallint : WriteInteger (Field, VarDummy);
      VarSingle   : WriteFloat(Field, VarDummy);
      VarDouble   : WriteFloat(Field, VarDummy);
      VarCurrency : WriteCurrency(Field, VarDummy);
      VarDate     : WriteDateTime(Field, VarDummy);
      VarBoolean  : WriteBool(Field, VarDummy);
      VarString   : WriteString(Field, VarDummy);
    end;
    CloseKey;
  end;
  RegIniFile.Free;
end;

{------------------------------------------------------------------------------}

function GetFromRegistry(RootKey : HKEY; Localkey, Field : String; VarDummy : Variant) : Variant;
begin
  Result := VarDummy;
  RegIniFile := TRegIniFile.Create('');
  case RootKey of
    HKEY_CLASSES_ROOT,
    HKEY_CURRENT_USER,
    HKEY_LOCAL_MACHINE,
    HKEY_USERS,
    HKEY_PERFORMANCE_DATA,
    HKEY_CURRENT_CONFIG,
    HKEY_DYN_DATA : regIniFile.RootKey := RootKey;
  end;
  with TRegistry(RegIniFile) do begin
    if OpenKey(Localkey,false) then begin
      if ValueExists(Field) then
        case VarType(VarDummy) of
          VarByte     : Result := ReadInteger(Field);
          VarNull     : Result := ReadInteger(Field);
          VarInteger  : Result := ReadInteger(Field);
          VarSmallint : Result := ReadInteger(Field);
          VarSingle   : Result := ReadFloat(Field);
          VarDouble   : Result := ReadFloat(Field);
          VarCurrency : Result := ReadCurrency(Field);
          VarDate     : Result := ReadDateTime(Field);
          VarBoolean  : Result := ReadBool(Field);
          VarString   : Result := ReadString(Field);
        end;
      CloseKey;
    end;
  end;
  RegIniFile.Free;
end;

function SureDlg(sText : String) : Boolean;
begin
  Result :=  (MessageDlg(sText, mtConfirmation, [mbYes, mbNo], 0) = mrYes);
end;

{------------------------------------------------------------------------------}

procedure InfoDlg(sText : String);
begin
  MessageDlg(sText, mtInformation, [mbOk], 0);
end;

{------------------------------------------------------------------------------}

procedure WarnDlg(sText : String);
begin
  MessageDlg(sText, mtWarning, [mbOk], 0);
end;

{------------------------------------------------------------------------------}

function  IsAppRunning(Name: PChar) : Boolean;
var  Mutex: THandle;
begin
  Mutex := CreateMutex(Nil, True, Name);
  Result := not ((Mutex <> 0) and (GetLastError = 0));
end;

{------------------------------------------------------------------------------}

end.
