unit ekbview;

interface

uses
  Windows, SysUtils, Classes;

type
 TEKBdata = record
    case Integer of
    0: (by: array[0..$4FF] of Byte);  // 1280 Byte
    1: (wo: array[0..$27F] of Word);  //  640 Word
    end;
 TwRecord= record
    case Integer of
    0: (b: array[0..63] of Byte);
    1: (W: array[0..31] of Word);
    end;
 TEKB_info= record
    Name:string[92];
    SerNum:string[10]; // 
    CountInst:byte; //  
    CountTotal:byte; //  max 254
    fHRD:boolean; //  HRD    
 end;
var
  sFilename: String;
  rEKBdata,rEKBdata0,rEKBdataAx,rEKBdataAx0:    TEKBdata;
  EKB_info:  TEKB_info;
  wRec:TwRecord;
  byteArtEKBQuersum_06079: Word;
  byte_067AA: Byte;
  byte_067AB: Byte;
  byte_067AC: Byte;
  dwTickCount: DWord;
  byteZahlH: Byte;
  byteZahlL: Byte;
  QuerPass: Byte;
  bTicH: Byte;
  bTicL: Byte;
  sCode: String;
  bAnzahl: Byte;

function fBerechneFreischaltCode(bAnzahl, bTicH, bTicL: Byte): string;
function fBezeichung: String;
function fCodeDreiAufEins(abyCode: array of byte): byte;
function fEKBtesten: Word;
function fEKBtestenArr(EKBdata:TEKBdata): Word;
function fHolePasswortKlartext: String;
function fNummer: string;
function fNummerArr(EKBdata:TEKBdata): string;
function isLegalInteger(wert: string): Boolean;

procedure pCodeEinsAufDrei(bNum: byte; var bAh, bCl, bCh: Byte);
procedure pEKBlesen;
procedure pEKBumCodieren;
procedure pEKBumCodierenUnpacked;
procedure pEKBumCodierenArr(var EKBdata:TEKBdata);
procedure pEKBumCodierenComment(s:string);
procedure pEKBxorPasswort;
procedure pReCalcTic(sCode: string; var bTicH, bTicL: Byte);


implementation

procedure pEKBlesen;
var S: TStream;
    ErrorMode: word;

begin

   {Meldung eines kritischen Systemfehlers vehindern}
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   try
     if DiskSize(1) = -1 then
       begin
         sFilename:='';
       end;
   finally
     {ErrorMode auf den alten Wert setzen}
     SetErrorMode(ErrorMode);
   end;

   if sFilename='' then exit;

   if NOT(FileExists(sFilename)) then
   begin
     sFilename:='';
     exit;
   end;


   S:= TFileStream.Create(sFilename, fmOpenRead);
   S.Read(rEKBdata.by, 1280);
   S.Free;

end;

function fEKBtesten: Word;
var ix: Integer;
    wQuer,wt: Word;

begin
    wQuer:= 0;
    byteArtEKBQuersum_06079:= 0;

    { Summe aus allen - bis auf die letzten zwei Bytes bilden }
    for ix:=0 to ($4FE-1) do
    begin
       wQuer:= Word(wQuer + rEKBdata.by[ix]);
    end;

    { Das Ergebnis mit 2805hex XORen }
    wQuer:= wQuer XOR $2805;

    { schauen ob die Quersumme im File gleich dem errechneten }
    if wQuer = rEKBdata.wo[$27F] then
    begin
       byteArtEKBQuersum_06079:= 0;   // Quersumme OK Type 0
       fEKBtesten:= 0;
       exit;
       { Abbruch - FERTIG -------------------------------  OK_0}
    end;

    { nochmals XORen }
    wQuer:= wQuer XOR $6729;

    { schauen ob die Quersumme im File nun bereinstimmt }
    if wQuer = rEKBdata.wo[$27F] then
    begin
       byteArtEKBQuersum_06079:= 1;   // Quersumme OK Type 1
       fEKBtesten:= 0;
       exit;
       { Abbruch - FERTIG -------------------------------  OK_1}
    end;

    { Quersumme im File ist NICHT OK }
    fEKBtesten:= $FFFF;    // FEHLER
end;

function fEKBtestenArr(EKBdata:TEKBdata): Word;
var ix: Integer;
    wQuer,wt: Word;

begin
    wQuer:= 0;
    byteArtEKBQuersum_06079:= 0;

    { Summe aus allen - bis auf die letzten zwei Bytes bilden }
    for ix:=0 to ($4FE-1) do
    begin
       wQuer:= Word(wQuer + EKBdata.by[ix]);
    end;

    { Das Ergebnis mit 2805hex XORen }
    wQuer:= wQuer XOR $2805;

    { schauen ob die Quersumme im File gleich dem errechneten }
    if wQuer = EKBdata.wo[$27F] then
    begin
       byteArtEKBQuersum_06079:= 0;   // Quersumme OK Type 0
       fEKBtestenArr:= 0;
       exit;
       { Abbruch - FERTIG -------------------------------  OK_0}
    end;

    { nochmals XORen }
    wQuer:= wQuer XOR $6729;

    { schauen ob die Quersumme im File nun bereinstimmt }
    if wQuer = EKBdata.wo[$27F] then
    begin
       byteArtEKBQuersum_06079:= 1;   // Quersumme OK Type 1
       fEKBtestenArr:= 0;
       exit;
       { Abbruch - FERTIG -------------------------------  OK_1}
    end;

    { Quersumme im File ist NICHT OK }
    fEKBtestenArr:= $FFFF;    // FEHLER
end;

procedure pEKBumCodieren;
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin

   bMask:= $67;
   if byteArtEKBQuersum_06079 = 1 then
   begin
      for i:= 0 to ($4FE-1) do
      begin
         rEKBdata.by[i ] := rEKBdata.by[i ] XOR bMask;
         bMask:= byte(bMask) + 1;
      end;
   end;

// Alles mit 0706hex + IDX XORen
   wMask:= $0706;
//   for i:= 0 to ((1280 / $20)-1) do   //1280 Byte / 32Byte = Anzahl der Blcke
   for i:=0 to 39 do // 40 Blcke
   begin
      for ix:= 0 to $10-1 do   // Je Block 16 Worte
      begin
         z:= (i*$10) + ix;     // BlockIndex * 16 + Index
         if z < $27F then      // CRC nicht umhacken
         rEKBdata.wo[z] := rEKBdata.wo[z] xor wMask;
      end;
      wMask:= Word(wMask +1);
   end;
end;

procedure pEKBumCodierenUnpacked;
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin
   bMask:= $67;

// Alles mit 0706hex + IDX XORen
   wMask:= $0706;
//   for i:= 0 to ((1280 / $20)-1) do   //1280 Byte / 32Byte = Anzahl der Blcke
   for i:=0 to 39 do // 40 Blcke
   begin
      for ix:= 0 to $10-1 do   // Je Block 16 Worte
      begin
         z:= (i*$10) + ix;     // BlockIndex * 16 + Index
         if z < $27F then      // CRC nicht umhacken
         rEKBdata.wo[z] := rEKBdata.wo[z] xor wMask;
      end;
      wMask:= Word(wMask +1);
   end;
end;

procedure pEKBumCodierenComment(s:string);
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
    sWord:word;
begin
   //s:=' '+s;
   wMask:= $072b;
//   for i:= 0 to ((1280 / $20)-1) do   //1280 Byte / 32Byte = Anzahl der Blcke
   for i:=0 to 63 do wRec.b[i]:=ord(s[i+1]);
    for ix:= 0 to 23 do   // Je Block 16 Worte
      begin
         z:= $258 + ix;     // BlockIndex * 16 + Index
         if ix>7 then wMask:= $072c ;
         rEKBdata.wo[z] := wRec.w[ix] xor wMask;
      end;
end;



procedure pEKBumCodierenArr(var EKBdata:TEKBdata);
var i, ix, z: Integer;
    wMask: Word;
    bMask: Byte;
begin
    fEKBtestenArr(EKBdata);
   bMask:= $67;
   if byteArtEKBQuersum_06079 = 1 then
   begin
      for i:= 0 to ($4FE-1) do
      begin
         EKBdata.by[i ] := EKBdata.by[i ] XOR bMask;
         bMask:= byte(bMask) + 1;
      end;
   end;

// Alles mit 0706hex + IDX XORen
   wMask:= $0706;
//   for i:= 0 to ((1280 / $20)-1) do   //1280 Byte / 32Byte = Anzahl der Blcke
   for i:=0 to 39 do // 40 Blcke
   begin
      for ix:= 0 to $10-1 do   // Je Block 16 Worte
      begin
         z:= (i*$10) + ix;     // BlockIndex * 16 + Index
         if z < $27F then      // CRC nicht umhacken
         EKBdata.wo[z] := EKBdata.wo[z] xor wMask;
      end;
      wMask:= Word(wMask +1);
   end;
end;

function fBezeichung: String;
var ix: Integer;
    sBez: String;
begin
   sBez:= '';
   for ix:=$2A2 to $300 do
   begin
      sBez:= sBez + Char(rEKBdata.by[ix]);
   end;
   fBezeichung:= sBez;
end;

function fNummer: string;
var ix: Integer;
    sNum: String;
begin
   sNum:= '';
   for ix:= $1C0 to $1C9 do
   begin
      sNum:= sNum + Char(rEKBdata.by[ix] XOR $88);
   end;
   fNummer:= sNum;
end;

function fNummerArr(EKBdata:TEKBdata): string;
var ix: Integer;
    sNum: String;  //  
begin
   sNum:= '';
   for ix:= $1C0 to $1C9 do
   begin
      sNum:= sNum + Char(EKBdata.by[ix] XOR $88);
   end;
   fNummerArr:= sNum;
end;

function fHolePasswortKlartext: String;
var iEnd, i: Integer;
    sTemp: string;
    bMask, bZeiger, bErg: Byte;
begin
   iEnd:= rEKBdata.by[$D0] - 1;
   bMask:= $18;
   bZeiger:= $D1;

   if iEnd = 0
   then sTemp:= 'ERROR->LEER'
   else begin
      sTemp:= '';
      for i:= 0 to iEnd do
      begin
         bErg:= rEKBdata.by[bZeiger] XOR bMask;
         sTemp:= sTemp + char(bErg);
         bMask:= bMask +1;
         bZeiger:= bZeiger + 1;
         if bZeiger = $E0 then bZeiger:= $E8;
      end;
   end;
   fHolePasswortKlartext:= sTemp;
end;

procedure pEKBxorPasswort;
var bLang, bByteQuell, bByteZiel: Byte;
    i, iIdx: Integer;
begin
   bByteQuell:= 0;
   bByteZiel := 0;
   bLang:= rEKBdata.by[$D0] ;

   iIdx:= $D0+1;  // Index auf das naechste Element

   for i:=0 to bLang-1 do
   begin
      bByteQuell:= rEKBdata.by[iIdx];
      bByteZiel:= bByteZiel XOR bByteQuell;
      iIdx:= iIdx+1;
      if iIdx = $E0 then iIdx:= $E8;
   end;

   byte_067AA:= bByteZiel;
end;

procedure pCodeEinsAufDrei(bNum: byte; var bAh, bCl, bCh: Byte);
var ah, cl, ch: Byte;
begin
   ah:= bNum;
   cl:= 0;
   ch:= 0;

   while ((ah < $30) OR (ah > $39)) do
   begin
      ah:= ah - 5;           // -5
      cl:= cl + 1;
      if cl = $0A then      // Bei 10
      begin
         cl:= 0;              // RESET
         ch:= (ch + 1)    // bertrag
      end;
   end;

   bAh:= ah;
   bCl:= cl+$30;
   bCh:= ch+$30;
end;


function  fCodeDreiAufEins(abyCode: array of byte): byte;
var ah, cl, ch: Byte;
begin
   cl:= abyCode[0];
   ah:= abyCode[1];
   ch:= abyCode[2];

   while ((ch <> 0) OR (cl <> 0)) do
   begin                // bis die bertragszhler abgearbeitet
     ah:= ah + 5;       // Wert +5
     cl:= cl - 1;
     if cl= 0 then
     begin
        if ch > 0 then
        begin
           ch:= ch - 1;
           cl:= $0A;        // Wenn 10, dann bertrag -1
        end;
     end;
   end;

   fCodeDreiAufEins:= ah;
end;

procedure pReCalcTic(sCode: string; var bTicH, bTicL: Byte);
var abyCode: array[0..2] of Byte;
    bPassCRC: Byte;
begin
   pEKBxorPasswort; // Ergebnis in byte_067AA

   abyCode[0]:= Byte(sCode[1])-$30;
   abyCode[1]:= Byte(sCode[2]);
   abyCode[2]:= Byte(sCode[3])-$30;
   bTicH:= (fCodeDreiAufEins(abyCode) XOR byte_067AA);

   abyCode[0]:= Byte(sCode[4])-$30;
   abyCode[1]:= Byte(sCode[5]);
   abyCode[2]:= Byte(sCode[6])-$30;
   bTicL:= (fCodeDreiAufEins(abyCode) XOR byte_067AA);
end;

function fBerechneFreischaltCode(bAnzahl, bTicH, bTicL: Byte): string;
var sNum: String;
    b234, b567, b8910, b1123: Byte;
    b1, b2, b3: Byte;
    bCode: Byte;
begin
   sNum:= '';

   if bAnzahl < 1
   then bCode:= $17   // nur um 1 hher
   else bCode:= $18;  // auf Wert setzen
//-----------------------------------------------------
// Ausgleich TIC und Zahl in 567
   b567 := bTicH   xor $24;
// Wert Zhler in 111213
   b1123:= bAnzahl xor (b567 + 8);
   // Ausgleich auf Befehl $17/18, die Counterberechnung ausgleichen
   b234 := (bCode) xor (b567 + 8) xor b1123;

//-----------------------------------------------------
// Ausgleich auf $1A/$1B
{ Es muss alles ausgeglichen werden:
  Ausgleich = $17/18 xor b567 (aus oberer Gleichung)
                     xor TicL (eigener Tic)
                     xor $87  (Zahl)
                     xor (b567+8) aus Counterberechnung
                     xor b1123    aus Counterausgleich
}
   b8910:= (bCode+3) xor b567 xor bTicL xor $87 xor (b567 + 8) xor b1123;

//-----------------------------------------------------
   pCodeEinsAufDrei(b234, b1, b2, b3);
   sNum:= sNum + char(b1) + char(b2) + char(b3);
   pCodeEinsAufDrei(b567, b1, b2, b3);
   sNum:= sNum + char(b1) + char(b2) + char(b3);
   pCodeEinsAufDrei(b8910, b1, b2, b3);
   sNum:= sNum + char(b1) + char(b2) + char(b3);
   pCodeEinsAufDrei(b1123, b1, b2, b3);
   sNum:= sNum + char(b1) + char(b2) + char(b3);

   fBerechneFreischaltCode:= sNum;
end;

function isLegalInteger ( wert : string ) : Boolean ;

//-----------------------------------------------------------------------------
// Die Funktion isLegalInteger gehrt nicht zum Formular, sondern wird
// als unabhngige Hilfsfunktion verwendet, um einen String dahingehend
// zu berprfen, ob man ihn in einen Integr verwandeln kann.
// wert (in) : der zu berprfende string
// Rckgabe  : konnte der string gewandelt werden ( ja = true / nein = false )
//-----------------------------------------------------------------------------

  procedure touch ( i : Integer ) ;

  //---------------------------------------------------------------------------
  // Hilfsfunktion, die eine Variable anfat, ohne etwas mit ihr zu machen.
  // Wird dazu bentigt, um eine Warnung in isLegalInteger zu unterdrcken.
  //---------------------------------------------------------------------------

  begin
    // kein Code hier !
  end ;

var value : Integer ;          // Das Ergebnis der Umwandlung - wird nicht verwendet
    code : Integer ;           // Fehlercode des Umwandlungsversuches
begin                          // of isLegalInteger
  val(wert,value,code) ;       // String in Zahl umwandeln
  touch(value) ;               // Zahl anfassen, um Warnung zu unterdrcken
  result := (code = 0) ;       // Ist erfolgreich gewandelt worden ?
end;

end.
 